#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityLuckyMapCFG.h"
std::auto_ptr<M_ActivityLuckyMapCFG> M_ActivityLuckyMapCFG::msSingleton(nullptr);

int M_ActivityLuckyMapCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityLuckyMapCFGData* M_ActivityLuckyMapCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityLuckyMapCFGData>& M_ActivityLuckyMapCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityLuckyMapCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityLuckyMapCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityLuckyMapCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishName = element->Attribute("FishName");
		data.mOrder = element->IntAttribute("Order");
		data.mFishMultiple = element->Attribute("FishMultiple");
		data.mFishResource = element->Attribute("FishResource");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityLuckyMapCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyMapCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityLuckyMapCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityLuckyMapCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityLuckyMapCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "FishName", data.mFishName);
		LuaCfgHelper::readInt(L, "Order", data.mOrder);
		LuaCfgHelper::readString(L, "FishMultiple", data.mFishMultiple);
		LuaCfgHelper::readString(L, "FishResource", data.mFishResource);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityLuckyMapCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyMapCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityLuckyMapCFG* M_ActivityLuckyMapCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityLuckyMapCFG());
	}
	return msSingleton.get();
}

void M_ActivityLuckyMapCFG::Release()
{
	msSingleton.reset(nullptr);
}
